#include <stdio.h>

double funkcija(double a[], int n, double x)
{
	int i, pom=1;
	double y=0, p=0;
	
	/*Racunamo y*/
	for(i=0; i<n; i++){
		if(a[i]>=x){
			if(pom || a[i]<y){
				y=a[i];
				pom=0;
			}
		}
	}
		
	/*Hornerov algoritam*/
	for(i=n-1; i>=0; i--){
		if(a[i]<x)
			p=p*y+a[i];
	}

	return p;
}


/* 
Alternativno rjesenje (brisemo elemente niza a koji nam ne trebaju)
double funkcija(double a[], int n, double x)
{
	int i, j=0, pom=1;
	double y=0, p=0;
	
	for(i=0; i<n; i++){
		if(a[i]>=x){
			if(pom || a[i]<y){
				y=a[i];
				pom=0;
			}
		}
		else{
			a[j++]=a[i];
		}
	}
		
	for(i=j-1; i>=0; i--){
		p=p*y+a[i];
	}

	return p;
}
*/


int main(void)
{
	double a[]={1,3,-6,4,0,2}, x=2.5;
	int n=6;
	
	printf("Vrijednost polinoma je %g.\n", funkcija(a,n,x));

	return 0; 
}
